use chrono::{DateTime, Utc};
use sqlx::{postgres::PgPoolOptions, query_as, PgPool};
use uuid::Uuid;

#[derive(Clone, Default, sqlx::FromRow)]
pub struct User {
    pub id: Uuid,
    pub created_at: DateTime<Utc>,
}

async fn foo(conn: PgPool, user_id: Uuid) -> Result<User, ()> {
    let user = query_as!(
        User,
        r#"SELECT id, created_at FROM users WHERE users.id = $1"#,
        &user_id
    )
    .fetch_one(&conn)
    .await
    .map_err(|_| ())?;
    Ok(user)
}

#[tokio::main]
async fn main() -> Result<(), ()> {
    let conn = PgPoolOptions::new()
        .connect("DB HERE")
        .await
        .map_err(|_| ())?;
    let _user = foo(conn, Uuid::new_v4()).await?;
    Ok(())
}
